Bug 182320 - Review Request: gnome-build
Review Request: gnome-build
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: John Mahowald
Fedora Package Reviews List
:
Depends On: 182319
Blocks: FE-ACCEPT 189685
  Show dependency treegraph
 
Reported: 2006-02-21 15:27 EST by Paul F. Johnson
Modified: 2007-11-30 17:11 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-08-14 17:14:42 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix myriad of issues with this spec (1.88 KB, patch)
2006-07-10 13:50 EDT, Paul Howarth
no flags Details | Diff

  None (edit)
Description Paul F. Johnson 2006-02-21 15:27:16 EST
Spec Name or Url: http://www.smmp.salford.ac.uk/packages/gnome-build.spec
SRPM Name or Url: http://www.smmp.salford.ac.uk/packages/gnome-build-0.1.2-1.src.rpm

Description:
This is the GNOME Build Framework (GBF) (required for anjuta2)
Comment 1 John Mahowald 2006-02-26 16:32:01 EST
Build failed on devel:  No Package Found for anjuta-gdl

Upstream source download URL is 404'd.

fedora-qa script found:
* Missing SMP flags. If it doesn't build with it, please add a comment
  (wiki: PackagingGuidelines#parallelmake)

Minor:
* Duplicate BuildRequires: gtk+-devel (by gnome-libs-devel), gnome-libs-devel
(by libglade-devel), libxml-devel (by libglade-devel), libglade-devel (by
gal-devel), gal-devel (by gtkhtml-devel)
Comment 2 John Mahowald 2006-02-26 16:33:18 EST
Should've done bug 182319 first. Making this depend on it.
Comment 3 Paul F. Johnson 2006-04-02 20:07:23 EDT
Can we move forward on this and #182319?
Comment 5 John Mahowald 2006-04-30 16:09:28 EDT
Missing some things when building against developement:

No Package Found for gnome-libs-devel
No Package Found for gtkhtml-devel
No Package Found for libglade-devel >= 2.0.1
No Package Found for gal-devel
No Package Found for oaf-devel


I'm not too familiar with Gnome devel packaging, but you'll probably want to
change to the lastest gtkhtml3-devel, and you'll have to change libglade-devel
to libglade2-devel to meet the version requirement.
Comment 6 Paul F. Johnson 2006-06-04 09:32:36 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.2-2.src.rpm

Change of URL
Comment 7 John Mahowald 2006-06-25 19:57:18 EDT
The BuildRequires mentioned in comment 5 still need to be changed.
Comment 8 Paul F. Johnson 2006-07-06 12:37:48 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-2.src.rpm

Updated spec and src.rpm
Comment 9 Paul F. Johnson 2006-07-07 20:09:52 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-3.src.rpm

Various rpmlint fixes
Builds in i386 mock
Comment 10 Michael Schwendt 2006-07-09 08:44:13 EDT
In what build environment did you try this?

  No Match for argument: oaf-devel
  No Match for argument: gnome-libs-devel
  No Match for argument: gal-devel

[...]
checking for pkg-config... no
checking for GBF... configure: error: The pkg-config script could not be found o
r is too old.  Make sure it
is in your PATH or set the PKG_CONFIG environment variable to the full
path to pkg-config.

Alternatively, you may set the environment variables GBF_CFLAGS
and GBF_LIBS to avoid the need to call pkg-config.
See the pkg-config man page for more details.

To get pkg-config, see <http://www.freedesktop.org/software/pkgconfig>.
See `config.log' for more details.
error: Bad exit status from /home/qa/tmp/rpm/tmp/rpm-tmp.74787 (%build)
Comment 11 Paul F. Johnson 2006-07-09 08:57:32 EDT
Building in FC-5. I'll fix the problems you've highlighted
Comment 12 Ian Burrell 2006-07-10 12:33:19 EDT
Is there a reason you are using the gnome 1 libraries to build gnome-build?  It
requires gnome2. The configure script says is needs gtk 2.3.0 and gnome 2.3.3.

The gnome-build.spec.in in the tarball is either really old or for another
distribution that packages gnome differently.  The nrpms.net gnome-build for FC4
uses the gnome2 dependencies.  Its requirements are:

BuildRequires:  gtk2-devel
BuildRequires:  gnome-vfs2-devel
BuildRequires:  libbonobo-devel
BuildRequires:  libglade2-devel
BuildRequires:  libgal2-devel
BuildRequires:  gdl-devel
BuildRequires:  gtkhtml2-devel
BuildRequires:  libxml2-devel
Requires:       gnome-vfs2
Requires:       libbonobo
Requires:       libglade2
Requires:       gtkhtml2
Requires:       libgal2
Requires:       gdl
Requires:       libxml2


Comment 13 Paul Howarth 2006-07-10 13:27:14 EDT
(In reply to comment #12)
> Is there a reason you are using the gnome 1 libraries to build gnome-build?

Yes; I read the spec too literally and it was a mistake. I'll remove them again.

I've had a look at the buildreqs that are actually needed for this package and
will attach a specfile patch shortly. The patch will also address the directory
ownership issues.

I'm doing a test build for mock/rawhide/i386 at the moment.
Comment 14 Paul Howarth 2006-07-10 13:50:39 EDT
Created attachment 132189 [details]
Fix myriad of issues with this spec

AFter applying this spec patch, the package builds in mock for rawhide. No need
for any Gnome-1 packages.

PFJ should chmod 644 his spec and tarball before building a new SRPM, and then
the only rpmlint issue left should be:

W: gnome-build-devel no-documentation

Given that the perl modules in /usr/share/gnome-build/GBF are not going to be
found by any random perl package that looks for them in standard places, I
would advocate stripping out the perl requires and provides from the main
package altogether. See: http://fedoraproject.org/wiki/Packaging/Perl
Comment 15 Paul F. Johnson 2006-07-11 10:33:34 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-5.src.rpm

Fixed all of the above problems as well as stripping out the perl stuff.
Comment 16 Paul Howarth 2006-07-11 11:24:10 EDT
(In reply to comment #15)
> Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
> SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-5.src.rpm
> 
> Fixed all of the above problems as well as stripping out the perl stuff.

You've just copied the perl dep-stripping stuff verbatim from the wiki page,
including the literal text "unwanted_provide" and "unwanted_require". You're
supposed to replace that text with a sed regex matching the perl deps you're
trying to get rid of (it's unusual to want to get rid of all of them as is the
case here).

You should check that you've got this right by doing:
$ rpm -qp --provides your-binary-rpm-filename
$ rpm -qp --requires your-binary-rpm-filename
after building them to make sure that the provides and requires are as you want
them. If the perl deps are still there, the filter isn't working.
Comment 17 John Mahowald 2006-07-20 23:33:49 EDT
make LIBTOOL=/usr/bin/libtool contains a hardcoded /usr/bin and lacks SMP flags.

And yup, the perl requires are still there.

Source0 is not downloading for some reason.

Comment 18 Paul F. Johnson 2006-07-23 11:42:24 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-5.src.rpm

It still lacks the smp flags as my system doesn't always like smp flags. No idea
why and have never been able to trace the fault (it won't, for example compile
anjuta2 with smp flags on)

libtool now fixed as is the perl issue.
Comment 19 John Mahowald 2006-07-27 00:07:02 EDT
W: gnome-build mixed-use-of-spaces-and-tabs

E: gnome-build shlib-with-non-pic-code /usr/lib64/libgbf-1.so.0.0.1
E: gnome-build shlib-with-non-pic-code /usr/lib64/libgbf-widgets-1.so.0.0.1

For some reason -fPIC isn't working on these libraries.
Comment 20 Paul F. Johnson 2006-07-29 19:04:31 EDT
Strange. I can't replicate this problem on either x86 or x86_64. I've fixed the
space and tabs problem though.
Comment 21 Paul F. Johnson 2006-08-01 06:51:46 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec

Updated spec file (the SRPM is the same)

Contains fPIC fix, spaces/tabs fix and Source0 fix
Comment 22 Paul F. Johnson 2006-08-10 06:52:40 EDT
ping!
Comment 23 John Mahowald 2006-08-13 23:28:51 EDT
Given that -fPIC is being passed let's ignore shlib-with-non-pic-code.

A couple things yet to address:
Needs work:
- Fix the cp line in %install to a %doc macro or explain why it's needed.
- missing smp flags or a note on why not needed (was in 0.1.2-2 ?)

Recommend:
* Changing URL to http://www.gnome.org/projects/devtools/gnomebuild.shtml

Good:
+ license (GPL)
+ sources good
+ builds on devel x86_64
+ %find_lang macro
+ version-release good, is latest
+ macros used consistently
+ proper -devel subpackage
+ %clean good
+ ldconfig good
+ proper file ownership
+ proper permissions
+ removed .la files
Comment 24 Paul F. Johnson 2006-08-14 06:39:44 EDT
Spec Name or Url: http://www.knox.net.nz/~nodoid/gnome-build.spec
SRPM Name or Url: http://www.knox.net.nz/~nodoid/gnome-build-0.1.3-8.src.rpm

Fixes #23
Added pkgconfig as a R for the -devel package
Comment 25 John Mahowald 2006-08-14 17:03:03 EDT
rpmlint just says W: gnome-build-devel no-documentation

Dependencies OK.

APPROVED as per comment 23.
Comment 26 Paul F. Johnson 2006-08-14 17:14:42 EDT
Thanks for the review. Much appreciated.
Comment 27 Paul Howarth 2006-08-15 03:34:28 EDT
There is still a dependency on perl(GBF::Make) in the built package, which makes
it uninstallable.
Comment 28 Paul F. Johnson 2006-08-15 04:46:19 EDT
Dammit!

The package itself creates perl(GBF::Make). It looks like I'll need to
explicitly include that it provides perl(GBF::Make).
Comment 29 Paul Howarth 2006-08-15 05:14:20 EDT
(In reply to comment #28)
> The package itself creates perl(GBF::Make). It looks like I'll need to
> explicitly include that it provides perl(GBF::Make).

I think you should filter out the perl(GBF::Make) dependency, as you've done
with the others. This is because the perl modules provided by and used by this
package are not in the standard perl module install directories, which means
that no other packages will be able to use these perl modules unless they know
exactly where to look for them.

I'd check to ensure that no perl Provides: have slipped through as well.

Note You need to log in before you can comment on or make changes to this bug.